﻿package implement

import (
	"code.fnuoos.com/zhimeng/model.git/src/super/dao"
	"code.fnuoos.com/zhimeng/model.git/src/super/model"
	zhios_order_relate_logx "code.fnuoos.com/zhimeng/model.git/utils/logx"
	"xorm.io/xorm"
)

func NewGenerateWxAdDataDb(engine *xorm.Engine) dao.GenerateWxAdDataDao {
	return &GenerateWxAdDataDb{Db: engine}
}

type GenerateWxAdDataDb struct {
	Db *xorm.Engine
}

func (g GenerateWxAdDataDb) UpdateGenerateWxAdDataBySession(session *xorm.Session, m *model.GenerateWxAdData, columns ...string) (int64, error) {
	affected, err := session.Where("id =?", m.Id).Cols(columns...).Update(m)
	if err != nil {
		return 0, err
	}
	return affected, nil
}

func (g GenerateWxAdDataDb) GetGenerateWxAdData(id int) (data *model.GenerateWxAdData, err error) {
	data = new(model.GenerateWxAdData)
	has, err := g.Db.Where("id =?", id).Get(data)
	if err != nil {
		return nil, zhios_order_relate_logx.Error(err)
	}
	if has == false {
		return nil, nil
	}
	return data, nil
}

func (g GenerateWxAdDataDb) GenerateWxAdDataInsertBySession(session *xorm.Session, m *model.GenerateWxAdData) (int64, error) {
	insertAffected, err := session.InsertOne(m)
	if err != nil {
		return 0, err
	}
	return insertAffected, nil
}
